version 2.14.0 (4.14.0)

* Reopening of changelog for stuff not covered by "Version Fixed In" queries at http://bugs.kde.org
* UML2 ports on components
* UML2 interface ball and socket notation 
* Improved C++ import (map declarations to correct namespace)
* Crash fixes in all language importers
* Improved loading of Rose models: Added support for controlled units and class diagrams
* Support for loading ArgoUML files (without diagrams)
* Support for loading Embarcadero Describe files (without diagrams)
* Umbrello crashes when Generate code function is used. (256716)
* Umbrello Crash when opening XMI (332612)
* Segmentation fault when opening a file that contains an "alternative" combined fragment (337606)
* class importer inserts classes in the wrong package (191894)
* Instable position of activity pins (335399)
* Ada is generated only for one class per package (336933)
* Slow click selection reaction in state diagram (337463)
* Find in diagram function (116354)


version 2.12.x (4.12.x)

* End of manual maintained changelog file
* Bug and feature related changelog can be fetched from http://umbrello.kde.org/changelog.php?4.12 

version 2.11.3 (4.11.3) unreleased

* Update documentation window on key navigation (151047)
* Fix potential crash on code generation. (Joris Steyn)
* Fix multiple association widgets for single foreign key constraint. (319391 122304)
* The problem with copy-pasting in the tree view is fixed. (291749)
* Double click on a state other than initial, normal or end crashed the application. Fixed by using a string instead of an array. (324192 324192)
* Rename all occurrences of uml.sf.net to umbrello.kde.org. (Ralf Habacker)

version 2.11.2 (4.11.2)

* Fix broken entries in tree view (with cleanup of obsolete code) (317602)

version 2.11.1 (4.11.1)

* Add visual feedback if widget has documentation. (324062)
* Move of UMLWidget based selection paint handling to UMLWidget::paint(). (Ralf Habacker)
* fix the SKIP regexp. (Allen Winter)
* Crash fix. (324058)
* Fix NoteWidget position of lower and right border, which are one unit to small. (Ralf Habacker)
* Rename of uml-devel@uml.sf.net to umbrello-devel@kde.org backport to 4.11.1 (Burkhard Lück)

version 2.11.0 (4.11.0)

* Some alignment operations do not match menuitem label and icon (207692)
* Attempting to right-align notes in a sequence diagram makes them left aligned (241200)

version 2.10.97 (4.10.97)

* Type int replaced with qreal. (Andi Fischer)
* Printing border fix. (115630)
* Fixed pixmap size problem painting diagrams into. (Ralf Habacker)
* Add small area around items when rendering a graphicsscene for printing or bitmap export to avoid border clipping. (154523)
* Removed unused method UMLWidget::updateLook(). (Ralf Habacker)
* Crash on ER foreign key constraint save (168273)

version 2.10.90 (4.10.90)

* Add git changelog maintainer script. (Ralf Habacker)
* Add maintainer script which lists duplicate xmi ids. (Ralf Habacker)
* Fixed bug removing the fractional digits when load widgets coordinates from xmi file. (321581)
* Fixed "mouse double click collision." - add point part (321255)
* Unify delta value for AssociationLine::closestSegmentIndex(). (Ralf Habacker)
* Add vertical state diagram auto layout. (Ralf Habacker)
* use better name ListPopMenu::insertAssociationTextItem (Ralf Habacker)
* Improve API of associationline by - removing the dependencies to umlscene and umlview - renaming pointIndex to just index. (Andi Fischer)
* Exclude last point from deleting point using context menu. (Ralf Habacker)
* Fixed "mouse double click collision." - delete point part (321255)
* Inform UMLListView about starting of rename when using F2. (Ralf Habacker)
* Removed F2 key disable hack on list view; it works now. (Ralf Habacker)
* Data loading in QActions data field fixed for different usage. (Andi Fischer)
* Debug calls updated. White spaces removed. (Andi Fischer)
* When a containment association was changed to another type, the circle was still visible. Fixed now. (Andi Fischer)
* Remove warnings of type: "QGraphicsScene::addItem: item has already been added to this scene" (Ralf Habacker)
* Cleanup of adding widgets to QGraphicsScene. (Ralf Habacker)
* Migrate UMLScene::diagramRect() to use QGraphicsScene::itemsBoundingRect(), which uses widgets bounding rect to determine scene size. (Ralf Habacker)
* Some actions in popup menu fixed. Containment symbol position fixed. (Andi Fischer)
* Fix the drawing of association lines. (Andi Fischer)
* Renamed AssociationLine::closestPointIndex() to closestSegmentIndex(), which is what it does in truth (Ralf Habacker)
* Unified used distance between isPoint() and closestPointIndex(). (Ralf Habacker)
* Crash fix in UMLScene::getFirstMultiSelectedWidget(). (Ralf Habacker)
* Fixed "Combined fragment has incomplete color settings". (321260)
* compile warning-- in CodeImpStatusPage::importNextFile() (Ralf Habacker)
* On mouse double click show only the item properties dialog. (Andi Fischer)
* Debug code removed. (Andi Fischer)

version 2.10.80 (4.10.80)

* Removed obsolete offset.. parameters from paint related MessageWidget methods. Also changed parameter type from QPainter& to QPainter *. (320463)
* Renamed drawSelected() to paintSelected() (320463)
* compiler warning-- (320463)
* Removed obsolete methods. (320463)
* Doc fix. (320463)
* Migrate PreconditionWidget::draw() to qt4 paint api. (320463)
* Migrate ArtifactWidget::draw() to qt4 paint api. (320463)
* Removed debug painting. (320463)
* Fixed widget painting artifact when widget line with > 1. (321053)
* Fixed widget painting artifact when widget line with > 1. (321053)
* Crash fix. (319276)
* Get rid of 'the the's (Yuri Chornoivan)
* Migrate PinWidget::draw() to qt4 paint api. (320463)
* Use camel case variable name. (320463)
* Migrate SignalWidget::draw() to qt4 paint api. (320463)
* Migrate ObjectWidget::draw() to qt4 paint api. (320463)
* Migrate UseCaseWidget::draw() to qt4 paint api. (320463)
* Migrate StateWidget::draw() to qt4 paint api. (320463)
* Migrate RegionWidget::draw() to qt4 paint api. (320463)
* Migrate PackageWidget::draw() to qt4 paint api. (320463)
* Removed obsolete call to setPenFromSettings() (320463)
* Migrate ObjectNodeWidget::draw() to qt4 paint api. (320463)
* Migrate NoteWidget::draw() to qt4 paint api. (320463)
* Migrate Nodewidget::draw() to qt4 paint api. (320463)
* Crash fix. (319276)
* Migrate MessageWidget::draw() to qt4 paint api. (320463)
* Migrate ForkJoinWidget::draw() to qt4 paint api. (320463)
* Migrate FloatingTextWidget::draw() to qt4 paint api. (320463)
* Migrate EnumWidget::draw() to qt4 paint api. (320463)
* Migrate EntityWidget::draw() to qt4 paint api. (320463)
* Migrate DataTypeWidget::draw() to qt4 paint api. (320463)
* Migrate ComponentWidget::draw() to qt4 paint api. (320463)
* Removed obsolete call to setY(), which has already been called in UMLWidget::loadFromXMI(). (320463)
* Crash fix caused by removing a FloatingDashLineWidget from the gui but not from CombinedFragmentWidget::m_dashLines. (320463)
* Avoid double painting of FloatingDashLineWidget; it is painted by QGraphicsScene already. (320463)
* Fixed FloatingDashLineWidget painting artifacts caused by not set widget height. (320463)
* Migrate FloatingDashLineWidget::draw() to qt4 paint api. (320463)
* Migrate CombinedFragmentWidget::draw() to qt4 paint api. (320463)
* Event handler contextMenuEvent used instead of old setupPopupMenu functions. (Andi Fischer)
* Get rid of 'the the's (Yuri Chornoivan)
* Migrate ClassifierWidget::draw() to qt4 paint api. (320463)
* Migrate CategoryWidget::draw() to qt4 paint api. (320463)
* Migrate BoxWidget::draw() to qt4 paint api. (320463)
* Migrate ActivityWidget::draw() to qt4 paint api. (320463)
* Migrate ActorWidget::draw() to qt4 paint api. (320463)
* Re-enable including of inherited methods on adding messages to sequence diagram. (306785)
* Prevent recursive search loops. (306785)
* Cosmetic update of documentation (Yuri Chornoivan)
* Import XMI_FILE_VERSION. (Ralf Habacker)
* Moved XMI_FILE_VERSION to version.h where app version definition already is. (Ralf Habacker)
* Refactored ID::Type related conversion functions similar to other types in basictypes.* (Ralf Habacker)
* Enable guard against recursive inheritance loops to self. (306785)
* Fixed synchronous message painting artifacts. (320109)

version 2.10.5

* Add vertical state diagram auto layout (Ralf Habacker)
* Fixed widgets painting artifact (321053)
* Prevent recursive search loops (306785)
* Umbrello Crash Upon Creation of Activity in Activity Diagram (319276)

version 2.10.4

* Fixed crash on adding sequence diagram messages by breaking recursive inheritance loops (306785)
* Fixed todo: This should be moved to somewhere in MessageWidget, refactor with messagewidgetcontroller.cpp:44 (Ralf Habacker)
* Fixed moving selected association lines todo (Ralf Habacker)
* Fixed painting of message widgets (320109)
* Move bounding rectangle related methods and class members to WidgetBase (Ralf Habacker)
* Increase resolution by using UMLSceneValue in ObjectWidget::messageOverlap() (Ralf Habacker)
* Fixed bug where resizing synchronous message moves its position (319813)
* Fixed bug where the sequence line is not moved along with the object widget (320018)
* Remove erroneous double-quotes around %c in Exec line (David Faure)
* Fix of llvm-clang bug reports (319129)
* Crash fix accessing zero pointer (314999)

version 2.10.3

- no changes

Version 2.10.2

* Auto detection fix of dot path on windows (Ralf Habacker)
* UMLSceneDrag...Event -> QGraphicsSceneDragDropEvent (Ralf Habacker)
* i18n: use i18n instead of i18n2tr (Pino Toscano)
* initialize in the correct order (Pino Toscano)
* Speed up c++ code import by hiding the list view dock window. (316829)
* Add 'resolve dependencies' option to c++ code import settings. (316829)
* Avoid recursion in non thread mode of import wizard. (Ralf Habacker)
* Crash fix of import wizard using threads. (Ralf Habacker)
* Fix my email address (Albert Astals Cid)
* Move dock windows visible switches to settings menu. (Ralf Habacker)
* Add error condition marker to activity diagram.. (Ralf Habacker)
* Add activity diagram containing all elements. (Ralf Habacker)
* Size problem fix when flipping fork/join state widget orientation. (Ralf Habacker)
* Crash fix when adding widgets to state diagram. (Ralf Habacker)
* Add class diagram containing all elements. (Ralf Habacker)
* Increase the border of the 'Fit in view' function, which makes it looking better. (Ralf Habacker)
* Fix broken connection (missing const). (Ralf Habacker)
* Fix bug not displaying toolbar because of broken widget connection. (Ralf Habacker)
* Some Krazy issues about including QtModules fixed. (Andi Fischer)
* uDebug replaced by DEBUG macro. (Andi Fischer)
* Consistent calls to debug output. (Andi Fischer)
* Enum Corner inside class with special operators. (Andi Fischer)
* More unit tests added for basictypes. (Andi Fischer)
* Namespace added for ParameterDirection. (Andi Fischer)
* Namespace added for enum RoleType. (Andi Fischer)
* fixed testcase bug (Ralf Habacker)
* Fix of scene limits when moving widgets. (315888)
* Rename the term 'canvas' to 'scene' in the documentation. 
  Remove unused UMLWidget::canvas() and setCanvas().
  Rename method AssociationLine::canvas() to umlScene().
  Rename method UMLScene::resizeCanvasToItems() to resizeSceneToItems(). (Ralf Habacker)
* Some basictypes classes changed back to enums and namespace. (Andi Fischer)
* cmake: various cleanups (Pino Toscano)
* Qt::ButtonState -> Qt::MouseButton (Pino Toscano)
* QTextOStream -> QTextStream (Pino Toscano)
* QChar::null -> QChar::Null (Pino Toscano)
* really remove the leftover of revision support (Pino Toscano)
* SVN revision logic removed. (Andi Fischer)
* Some basictypes classes changed back to enums and namespace. (Andi Fischer)
* Add auto layout test file. (Ralf Habacker)
* Add bug numbers and release version (Ralf Habacker)
* Comments moved from header to source file. (Andi Fischer)
* Add "view" menu containing toggle entries for the tree, documentation and command history view. (Ralf Habacker)
* Removed another widget moving limit. (Ralf Habacker)
* Do not limit new position on widget move, instead follow already implemented rule on widget creating. (Ralf Habacker)
* Fixed Fit-in-window feature. (Ralf Habacker)
* Removed another widget moving limit. (Ralf Habacker)

Version 2.10.1

* New feature: Fit diagrams in view after applying layout to get better overview (315889)
* Add view menu to switch on tree, doc and command history view (315891)
* Update zoom slider and percent value when switching diagrams (315885)
* Made "Fit" button working (315887)
* Fixed scene limits when moving widgets and/or loading xmi files (315888)

Version 2.10.0

* New feature: Line based grid drawing
* TreeView to diagram class drag problem (292042)
* Extend class debug filter (309770)
* UML diagrams outside image problem (309452)
* some state diagram widgets could not be added (309064)
* no classes displayed after xmi file loading (309007)
* wrong origin of classes in print page preview (308959)
* migrate remaining qt3 classes to qt4 (290952)
* clicking undo twice in a row crashes Umbrello (119868)
* Umbrello crashes after undo action (266789)
* Segfault when loading a saved document (180145)
* unsorted operation list in add message widget property dialog of sequence diagrams (303263)
* Assertion on c++ import (303222)
* umbrello fails to parse escape sequences in c++ preprocessor statements (303137)

Version 2.9.0

* New feature: Drawing of state diagrams with more pseudostates possible.
* New feature: Export diagrams to graphviz dot format
* New feature: Auto layout of diagrams using external dot generator
* unsorted operation list in add message widget property dialog of sequence diagrams (303263)
* Assertion on c++ import (303222)
* umbrello fails to parse escape sequences in c++ preprocessor statements (303137)
* umbrello freezes on c++ import (302671)
* Segfault importing Java code (230770)
* Crash on new synchronous message in sequence diagram (168752)
* Segmentation fault when copy&paste of sequence diagram (287179)
* Hypergraphic and hierarchy links (67062)
* umbrello hangs on import of qatomic_x86_64.h (302384)
* layout generator auto detection (301969)
* category widget drawing problem (301595)
* Note widgets get resized when printing (152757)
* Note widget text is not editable through doc window (301181)
* umbrello crashes when importing templated java source code (293770)
* activity diagram, branch/merge: background fill not disabled (165799)
* Umbrello crashed when changing the Package of a class (268469)
* Cannot anchor note in state diagram (270597)
* Mistype in PostgreSQL codegenerator (275158)
* Missing newline in MySQL codegenerator results in output being partially
  commented out on some models (275164)
* Color of role text on diagram (e.g. Role B) nearly invisible (291401)
* Junk residual UMLAssociations saved to XMI (293042)
* Problems with widget moving/resizing in state diagrams (295605)
* State diagram deep/shallow history widget resizing problem (296331)

Version 2.8.1

* PHP5 code generation: Illegal tag without any parameter is generated (155382)
* Classes in sub-packages are moved to top level packages on edit (174184)
* Loading existing XMI file (194897) and therefore also
  -  umbrello (2.4.2) crashed while opening solid_design.xmi (233705)
* Generation of classes from files in folder in umbrello (197137)
* Crash when Clicking on / Trying to Move Datatype on Simple Diagram (202410)
* Segfault importing Java code - related to variable length parameters (230770)
* Segmentation fault when trying to generate code (235703)
* Can't uncheck "Show Public Only" (242545)
* Umbrello crashed after copy/paste (243392) 
* Crash when opening file (251094) 
* Crashes even if an association was drawn (271243)
* Gratuitous warning messages on loading project file (283744)
* Creates many 'new_package_xx' packages on file loading (291159)
* Crash on importing templated java source code (293770)
* New feature: C# code import added.

Version 2.8.0

* New feature: Code import wizard added
* New feature: Print preview added.
* Made printing border calculation more robust
* Reuse changed printer settings
* Show diagram print settings dialog before print or print preview dialog
* Added msvc2010 preprocessor for idl preprocessing
* Enabling of cut/copy/paste actions is incorrect (70925)
* Segmentation fault when copy&paste of sequence diagram (287179) and therefore also
  - Copy and paste or drag and drop of a java datatype between folders (280770) 
  - crash on copy paste (262842)
  - Crash when copy/paste, from a class tab to an other, 2 linked tables (286449)
  - Cut Class and paste as Entity cause crash (274265)
  - Umbrello crashed when cut/paste (275372)
  - Copy and paste of a class lets Umbrello crash (241915)
  - Copy - paste multiple class operations makes umbrello crash (257410)
  - Umbrello crashes during cut and paste class diagram (257584) 
* Copy/Paste of activity, state and use case diagram elements do not create new elements (291557)
* Crash on new synchronous message in sequence diagram (168752)
* Umbrello crashes with SIGSEGV in Object Flow properties 170596)
* Crash fix in case the path does not fit into the package hierarchy we cannot check the imports (200721)
* Crash fix on importing idl file (203092)
* Crash on C++ import with Doxygen: cause Doxygen Braces (228352)
* Crash on new entity (entity relationship model) (259404)
* Umbrello crashed when changing the Package of a class (268469)
* Compile error when build against Qt 4.8 (279184)
* Crash when importing Java-Source (288406)
* Improvements to widgets paste location (291763)
* Box widgets size could not be reduced  (291837)
* Widget clipping problem (291894)

Version 2.7.4 (and previous)

* ERD - wrong orientation of relation while entering FK (171280)
* Fails to compile with boost 1.37.0 (177755)
* Hangs exporting to EPS and PDF, creates broken files (180031, 185659)
* Crashed opening specific .xmi file (203118, 238775)
* Invalid types in PostgreSQL codegenerator (273221)

...

Version 2.0.0  (First Qt4/KDE4 based version)

* Bugs/wishes from http://bugs.kde.org:
* Turn off header/footer and page numbers when printing (69113)
* Code generation and undo/redo take up too much memory (72644)
  - Use the KUndoStack derived from QT4 QUndoStack in order to manage commands.
  - Commands are stored in cmds folder.
* Switching between tabbed and non-tabbed views requires restart (98204)
* Recursively scan source files when reverse engineering (109157)
* Implement the UML 2.0 standard (115269)
  - Sequence Diagram
    * Combined Fragments
      * Operators : Alternative, Option, Break, Parallel, Reference, Negative, Critical,
                    Ignore, Consider, Assertion, Loop.
      * Found / Lost Messages.
  - Sequence Diagram
      * Pre/Post conditions.
      * "accept time event" symbol.
      * Control Flow.
      * Object Flow.
      * interruptible region.
      * expansion region.
      * Control node : flow final.
      * Transformation.
      * Objects nodes :  
        * Activity Invoke.
        * Activity Parameter Nodes.
        * Central buffer nodes.
        * Data stores nodes.
        * Input / Output / Constant Pins.
* RMB LogicalView->New->Class in treeview creates TWO classes (144537)
* New code generator for D language
* Add option for automatic drawing attribute associations in class diagram (147061)
* Crash on exit after loading phonon design.xmi (149356)
* Crash on saving phonon design.xmi with Advanced Code Generators enabled (149357)
* Crash on exit after loading XMI file with Advanced Code Generators enabled (149457)
* Patch: Correct C# constructors - no return type (150988)

Version 1.5.8

* Bugs/wishes from http://bugs.kde.org:
* Cannot move text and label correctly after enabling snap to grid (137041)
* Umbrello gratuitously appends ".xmi" to the saved file name (146061)
* Wrong pascal code generation (146676)
* Crash when linking to undefined xmi.id (146748)
* End Activity Symbol gets invalid when line thickness is increased (146925)
* The size of a fork/join is not restored (147069)
* Crash when changing the association type to containment (147202)
* Moving component on diagram results in absurd shape of self-association (147810)
* Crash when changing the attribute name (147919)
* Reads XMI exported by version 1.5 but crashes when rereading after saving (147988)

Version 1.5.71

* Bugs/wishes from http://bugs.kde.org:
* Preprocessor keywords ignored which causes endless loop in code import (119125)
* Code generator for D language (124805)
* Unstable saves and loads, class names become dirty (145709)
* Crash on deleting class in list view (145762)
* Class attribute documentation not generated for python (145916)
* Python code generator does not wrap lines properly (145918)
* Attribute documentation not generated for 'Export to XHTML' (145972)
* Crash when moving a class in a Java UML diagram (146058)
* Arrowheads are not shown (146064)
* Crash when creating a class that refers to more than one other classes/datatypes (146367)

Version 1.5.7

* Bugs/wishes from http://bugs.kde.org:
* C# Code Generation and export (53368)
* Java interface inheritance, abstract classes and generics in code generation (53376)
* Code generation ignores unidirectional association (72042)
* Design bug in advanced code generators (84739)
* %date% and %time% not being parsed (96612)
* Operations of the Interface are not implemented in the class automatically (111593)
* Relationships for entities do not live outside of the diagram (125146)
* Multiplicity labels often are placed incorrectly (127628)
* Association role labels are duplicated (130172)
* Crash on adding operation to class with Advanced Code Generators enabled (131528)
* Javascript wrong Code Generation (135527)
* Javascript/ActionScript Code Generation creates bad format methods (135540, 144738)
* Sequence diagram object size incorrect after toggling "Draw as Actor" (136869)
* Incorrect Association Properties text (139872)
* Buttons are not displayed (139913)
* Impossible to reuse same use case in a use case diagram (140150)
* Java 5 generics support (140669)
* Associations not updated during move of class on diagram (140709)
* Crash when deleting the link between a package and a class (141602)
* Ada95 Code Generation Errors for Aggregation (141644)
* Unable to delete multiplicity information or label from an association (141813)
* Reinstate code generation options for C++ (141875)
* C++ code generator does not correctly define namespaces (141876)
* Ada code generator generates "withs" in both directions for certain associations (141956)
* Ada code generator always generates methods abstract even if abstract box not checked (142093)
* Missing "with" on Ada code generation for aggregation (142392)
* Operation Properties "Type" combo box too small (143319)
* Support duplication of diagrams (139856, 143581)
* Crash on changing multiplicity in an association in ERD (143909)
* Class diagram in folder not loaded correctly from xmi (144119)
* Sequence diagram crashes during message inserting (144293)
* No synchronisation of comments when round-tripping (144346)
* Crash when loading xmi with actor as object of sequence diagram (144442)
* ActionScript/JavaScript association code generation error (144788)
* Segmentation fault on loading corrupted file (145035)
* Crash when moving all elements in a sequence diagram (145202)

Version 1.5.61

* Copy/paste of attribute or operation in list view within same class
* Improved loading of files from older versions
* Ada import updated for Ada2005
* Bugs fixed from http://bugs.kde.org:
* Crash on creating various types of associations (140693, 141073, 141106, 141277)
* Unclickable use case diagram (140870)
* Crash on opening xmi file produced by previous version (141279)

Version 1.5.6

* Fixed save/reload of association widgets for collaboration diagrams
  http://www.geeksoc.org/~jr/umbrello/uml-devel/9825.html
  http://www.geeksoc.org/~jr/umbrello/uml-devel/9857.html
* Fixed crash in ToolBarStateArrow destructor
  http://www.geeksoc.org/~jr/umbrello/uml-devel/9861.html
* Stereotype selection list for parameter properties dialog
  http://www.geeksoc.org/~jr/umbrello/uml-devel/9862.html
* Note widget is now always drawn on TOP of all widgets
  http://www.geeksoc.org/~jr/umbrello/uml-devel/9863.html
* Optimized printer margins
  http://www.geeksoc.org/~jr/umbrello/uml-devel/9895.html
* Improved code import for Ada and Pascal (SVN commits: 621845, 622128, 622396, 623316,
                                           623421, and 624257)
* Bugs/wishes from http://bugs.kde.org:
* Association line nodes don't drag along with multiply-selected classes (57878)
* Disappearing parameters when editing class properties (114477)
* Umbrello saves too many copies in xmi (135606)
* XML scheme: mixup of attribute names: *color and *colour (136061)
* Artifacts of a component diagram are wrongly placed in Deployment View folder (137564)
* Incorrect export to SQL (138139)
* Parentheses do not appear around the parameters of the C++ operator() (139147)

Version 1.5.52

* Fixed segfault in UMLClassifier::checkOperationSignature()
  (http://www.geeksoc.org/~jr/umbrello/uml-devel/9816.html)
* Fixed segfault on XMI close when a class uses a template
  (http://www.geeksoc.org/~jr/umbrello/uml-devel/9818.html)
* Fixed crashes during Tcl code generation
* Fixed bugs in generated code of various code generators
* Bugs/wishes from http://bugs.kde.org:
* Shift + Left and Shift+Right causes SIGSEGV (136288)
* Crashes on closing/opening files created with previous umbrello versions (136940)
* Crash when opening saved document (136998)
* Faulty behavior when a class inside of a package is modified (137497)

Version 1.5.51

* This is an interim release that fixes a serious regression in version 1.5.5
  which is detailed at http://bugs.kde.org/135749 (Crash when opening a document)
* XMI file contains deleted associations (129859)
* Accessor methods are private instead of public (85553)

Version 1.5.5

* PHP5 generator creates stub methods for all interfaces a class implements (C. Brunsdon)
* Fix load of associations in collaboration diagram (A. Spangler)
* Fix for single selection of an unselected widget when other widgets are selected
* Fixes for several bugs in toolbar states
* Fix for message widget selection
* Fix for class association not updating the association position when being moved
* Bugs/wishes from http://bugs.kde.org:
* Export-to-docbook and Export-to-HTML documentation generator (54307)
* "role A properties" should give class name (69244)
* Sharing designs, Folders, 3rd Party imports (87252, reimplementation)
* "Open recent" list doesn't reorder when a file is opened (111757)
* Properties menu: move to top/bottom buttons (126467)
* Java import - importing interfaces - absent visibility treated as package
  instead of public (131327)
* Python code generation not independent of diagram view (131790)
* Java import - method parameter types not resolved correctly (131825)
* Java import: unable to import AzareusCore (131961)
* Java import: error on multidimensional arrays (132017)
* Java import - array types not resolved correctly (132035)
* Java import - "final" and comments in method declaration not parsed correctly (132174)
* Java import: spaces in strings cause next member var to be ignored (132472)
* Java import - static member vars ignored in interfaces (132657)
* Header file names are lowercase in .cpp file, but mixed case on the disk (134279)

Version 1.5.4

* Bugs/wishes from http://bugs.kde.org:
* Transform interface to class - fixes to some issues (79433)
* Free Pascal code import and generator (114547)
* Enable selection of multiple classes in "Select classes" dialog (126485)
* Crash after single click on the "UML Model" tree window (126560/129252)
* Fix crash when importing classes from a java file (129107, 130093)
* Cannot insert transition/association TO fork/join node in activity diagram (129914)
* Command line switches: graphics export to directory does not work with relative paths (130600)
* Importing java files that reference their own class name crashes (130735)
* Importing java class (enum pattern) cause umbrello to hang (130792)
* Importing java subinterface before superinterface results in superinterface
  not being treated as an interface (130793)
* Java import: method and class visibility ignored (130794)
* Java import - static not handled correctly (130926)
* Java import - package visibility incorrectly represented (130932)
* Java import - random import order can result in interface being treated as class (131006)
* Java import - associations not setup correctly, duplicate classes created (131270)

Version 1.5.3

* Switch to arrow tool after association creation (http://bugs.debian.org/353344)
* Bugs/wishes from http://bugs.kde.org:
* "Export all views" feature contributed by Daniel Calvi� S�chez (extension of 58809)
* Static variables in java code are not marked static (59190)
* New alignment type "distribute horizontally/vertically" (extension of 67058)
* Save autosave file to a more obvious place (72019)
* Usability and responsiveness improvements to code import (93296)
* Auto-complete in parameter properties dialog in class diagram (104477)
* Crash on application exit (112092)
* Memory problem when importing classes from c++ sources (122668)
* Nestable components and subsystems in Component diagram (124326)
* Crash loading xmi file (125331, 126968)
* User interaction with UMLWidget improvements (126391)
* Comments are cut short when generating PHP code (126480)
* Freeze on C++ class import (126994)
* Crash on importing Java 1.5 classes containing annotations (127160)

Version 1.5.2

* fixed problem reordering methods in classes/interfaces
  http://bugs.debian.org/348940 , http://bugs.kde.org/119991
* fixed problem with font size computation/word wrap in note widgets
  http://sourceforge.net/mailarchive/forum.php?thread_id=9558795&forum_id=472
* Automatically fill useful info into the Perl writer heading template
* Bugs/wishes from http://bugs.kde.org:
* Fixed connection points for associations on widgets (67223)
* Import Rose model files (81364)
* Documentation for association roles not saved (105661)
* Default data types not added for old Java generator (115991)
* Custom operations in sequence diagrams become class operations (120337)
* Fork/join symbol appears as a black box (120455)
* Multiplicity labels positioned incorrectly when moving entities (120598)
* Types of entity's attributes are displayed instead of their names (120742)
* Unable to delete entity from entity list in "UML Model" frame (120750)
* Interface names not italicized in diagram view (120761)
* Cannot Resize Sequence Diagram Synchronous Messages (120910)
* Sequencediagram: messages as constructor works only properly at 100% zoom (121238)
* drag 'n drop a class when the zoom is not 1:1 don't put the class under mouse cursor (122293)
* Documentation for associations is not retained (121478, 122063)
* Crash when a non existing data type is used for an argument of a new method (122497)
* Crash when importing Python files (121952)
* "void" is imported as class and not datatypes (122184)
* Crash when creating a datatype with the same name as a class (122188)
* Crash when refusing to rename a class on importing typedef (122914)
* Java import fails at abstract methods or interfaces (123661)

Version 1.5.1

* fix loading of associationwidget with non-default color
* fix moving of initial and end activity by inhibiting resize
* fix operation parameter and return types including template expressions
* Bugs/wishes from http://bugs.kde.org:
* Code import for Java and Python (79648)
* Support C++ const methods (aka queries, part of 60452)
* Change associations, aggregations, etc. on-the-fly (109963)
* Collaboration Diagram: labels are reset to default position after moving them (117791)
* Imported C++ classes not saved correctly in the XMI file (117875)
* In ER models adding associations will add blank space in the entity attributes (117990)
* ER diagrams need to underline the attribute name of primary keys (118570)
* Cannot anchor notes to activity elements in Activity Diagram (118719)

Version 1.5

* Association classes
* Advanced code generator for Ruby
* Code generator for Tcl
* Externalization of folders (i.e. submodel files)
* Change interface into class and vice versa (if abstract and no attributes)
* Image export via command line
* All diagram objects can be resized
* Automatic Diagram Layout (67059, not yet closed)

* Bugs fixed / wishes implemented (see http://bugs.kde.org)
 57588  57672  58809  66461  67120  67719  72016  79433  87252  88117
 97162  98368 101550 105564 107405 108223 109591 109636 110073 110216
110231 110379 110400 110843 111088 111470 111502 111759 111768 112017
112292 112293 112333 112531 112552 112936 112991 112992 113748 114892

Version 1.4.2 (maintenance release)

* Bugs fixed from http://bugs.kde.org :
97188 103170 106183 106356 106632 106673 107101 107551 108688

Version 1.4.1 (maintenance release)

Bugs fixed:
* Crash on deleting attributes / enum literals
* Crash in UMLView::createAutoAttributeAssociations()
* Failure to import C++ enum type with comment on last literal
* Non-Latin1 characters in diagram names
* Generate missing "static" keyword in new C++ code generator
* Bugs from http://bugs.kde.org :
 53376  57667  57875  70924  80924  89691  95353 100290 100307 101148
103123 103133 103728 101541 104637

Version 1.4

* Entity relationship diagrams

* Tabbed diagrams

* Object creation message in sequence diagram

* Notes can contain diagram hyperlinks

* Move canvas items using the keyboard (Alt + arrow keys)

* Improved support for parameterized classes

* CORBA IDL import

* PHP 5 code generator

* fixed many issues in Perl code generator 

* Bugs fixed / wishes implemented (see http://bugs.kde.org)
53380 53384 54928 55058 55242 57879 61945 62321 63316 67062
67723 69592 71978 74249 74952 75010 77645 80405 80559 82342
83834 84515 85136 85377 86083 86828 86952 86958 87111 87537
87956 87995 88152 88245 88415 88954 89334 89485 89553 89563
89579 89582 89699 89860 89903 90102 90106 90206 90755 91298
91433 91434 91494 91869 91922 92116 92123 92222 92300 92301
92781 92995 93122 93219 93297 93298 93501 93535 93696 94173
94728 94795 94883 95082 95247 95252 95722 95924 95951 95954
96216 96221 96964 97155 97182 97697 97887 97984 98603 98899
 99697 100142

Version 1.3

* heavily reduced memory usage and CPU load on large projects

* reserved keywords added for supported languages

* new tools for aligning several objects

* support added for compressed XMI files (*.xmi.tgz, *.xmi.tar.bz2)

* New diagram command 'Duplicate' permits the copying of diagram
  objects including their features

* New association type: Containment (circle-plus.)

* Operation parameters have a 'direction' which documents whether
  they are input or return values (in, out, inout.)
  The IDL and Ada generators use this in their generated code.

* Ability to show only public methods/members in diagram.

* Improvements to scaled printing.

* Crisp new icons

* Improved XMI standard conformance of the file format.
  In principle, Umbrello's XMI parser is now capable of
  reading foreign XMI files.

* Improved compatibility with old umbrello files

* Support for repeatedly importing the same C++ file(s)

* Umbrello places much less demand on the X server when
  dealing with large and complex diagrams

* Umbrello is still compilable with KDE 3.1 but if you have
  such an "ancient" KDE version the new compressed-XMI file
  format will not work.

* Bugs fixed / wishes implemented (see http://bugs.kde.org)
53361 53381 53383 55238 56184 57664 57875 66508 67058 68441
71281 71334 71805 71969 72016 72615 72617 72644 72801 72971
72977 73042 73139 73274 73275 73277 73278 73418 73521 73632
73926 73975 74432 74820 75111 75318 75380 75582 75789 75935
76114 76209 76506 77367 77377 78192 78317 78525 78806 78910
78912 79180 79188 79202 79631 79883 80119 80299 80824 80913
80999 81000 81790 82236 82315 82346 82406 82685 82743 82977
83052 83430 83432 83446 83449 83546 83553 84260 84262 84516
84549 84656 84574 85126 85196 85434 85552 85554


Version 1.2

* Canvas zoom

* Undo and redo

* Clipboard now uses XMI, old binary .uml file format no longer supported

* Resizeable canvas

* Refactoring agent

* Improved code export and many new code export languages

* Datatype and enum widgets and internal representation 

* Component and deployment diagrams

* Parameterised classes (templates in C++, generics in Java)

* Stereotypes on operations, attributes, etc

* Asymmetric and symmetric sequence diagram messages

* Corrected placement of the diamond in aggregations/compositions,
  the diamond is at the owning class

* Can change properties of multiple items at one time

* Code base is tightened up (no more WidgetData classes)

* Bugs fixed / wishes implemented (see http://bugs.kde.org)
  53354 53356 53357 53359 53362 53363 53365 53367 53371 53379
  53381 53385 53387 53388 53447 53487 53652 53653 53777 54183
  54446 54575 54816 54817 54822 54926 54969 55051 55236 55239
  55243 55245 55246 55247 55283 55300 55698 55729 55731 55810
  56166 56519 57054 57113 57197 57199 57200 57226 57424 57475
  57490 57521 57665 57669 57876 57877 57878 57881 57882 57883
  57886 57920 58339 58349 58426 58439 58489 58852 58854 59049
  59155 59190 59403 59408 59774 60139 60135 60204 60685 60981
  61972 62201 62276 63115 63248 63316 63884 63895 63897 64201
  64431 64435 64501 64502 64727 64881 64884 65183 65185 65312
  65389 65391 65407 65410 65411 65442 65444 65450       65530
  65635 66185 66442 66459 66461 66847 66848 66997 67209 67277
  67327 67765 67770 68095 68395 69330 69332 73926

Version 1.1.1

* No longer crashes when printing

* Capitalisation corrections in strings

Version 1.1 (including 1.1 rc 2)

* Activities can have multiple outgoing associations

* Updated and translated tips file

* New handbook help file

* Slovak translation added

* Updated German translation

* hopefully last changes needed for the name conversion to Umbrello

* i18n fixes

* Many bug fixes

Version 1.1 rc 1

* Pasting in sequence diagrams now works correctly

* Paste operation now shows dialogue messages when it can't paste everything or at all

* Cut now works

* Code generation wizard checks directory exists

* Code generation overwrite dialogue now lets you apply option to all remaining files

* Activity widgets now have borders

* Actors can be generalised from other actors

* Multiple objects can now be moved at once

* check for metamodel=UML when loading files

* Saved files have XML header

* code generation wizard gives feedback on whether the file was generated

* improved RPM spec file for multiple distributions

* tokenizer.l compatibility improved

* Can select which language to generate to from code generation panel

* User interface improvements (`new attribute' etc buttons added)

* Operations and attributes can have classifier scope (static)

* PHP code generation

* Some menu improvements

* Compiler warnings reduced

* i18n() added where it was missing

* Various operations which made it crash fixed

* Typos fixed

Version 1.1 beta 2

* Name changed to Umbrello UML Modeller

* Java filenames have correct capitalisation

* Grid is no longer printed

* Widgets now keep track of their colours and use diagram colours by default

* Open and save dialogues correctly remember where they were last

* Checks on saving to PNG if user really wants to save to an already existing file

* Sequence and collaboration messages always update when they should

* Consistent position for labels on sequence messages

* Nicer looking selection box

* "New operation" from sequence diagram messages will now be used automatically on that message

* Some improvements in menu consistency

* Delete selected widgets with Delete key

* Select all widgets on current diagram ability

* Size of left hand list view now saved

* White space removed from copying to PNG

* Import of file format 4 from UML version 1.0.3

* Solaris compatibility with setenv(), hopefully

* operations and attributes now show the correct UML syntax in class diagrams

Version 1.1 beta 1

* The AssocCopy, MessageCopy and CutCopyPaste classes have been
	replaced with CUMLDrag and CUMLClipboard.
	It supports 5 copy&paste types:
	-- multiple empty folders (selected from the listview)
	-- folders and multiple umlobjects (selected from the listview)
	-- folders, multiple umlobjects and umlviews (selected from the listview)
	-- multiple widget selection (from a diagram)
	-- multiple operation and attribute selection (from the listview)
	-- PNG clipboard support when copying for a diagram.
	currently there is no ability to cut

* Association can be non-straight, just double click on the line.

* the ..widgetData classes abstract widget data from actual widgets so there only
	needs to be as many widgets in memory as there are in the current diagram

* listview allows folders inside folders

* all UMLObjects now have associated documentation

* activity and state diagrams

* XMI based file system

* unicode UMLObject and diagram names

* QCanvas used rather than QWidget

* member variables now mostly use m_... format

* Code generation for C++ and Java

* Code import

* Fixed dos line endings and untagged binary files in CVS

* New project admin (Jonathan Riddell).  No thanks to Sourceforge.


Version 1.0.3

* Added rename, delete options to folders

* Text now remembers state

* Moving text in selection move, now moves all selected.

* Diagrams now into folders

* Can save/load files without diagrams (use to crash on load)

Version 1.0.2

* Added multiple selection of icons

* mass move, delete and toggle fill color

* Cut, Copy to image file of selected items or selected section of diagram

* Cut, Copy, Paste between diagrams.

* Correctly deletes message from sequence diagram.

* Recent files list now correctly handled

* Error on loading files now put Untitled correctly in the caption.

* Toolbars keep session settings

* Added folders for Actors, Use Cases and Concepts to help organisation

* Composition, Implementation, unidirectional associations and realizations added to class diagrams

* Generalization, dependency, and unidirectional associations added to use case diagrams.

* Changing text to nothing now hides the widget

Version 1.0.1

* Added package and stereotype options to Classes

* Added to options page package and stereotype options.

* print dialog added to printer interface to allow selection of diagrams to print.

* Note Box size set correctly after loading.

* Sequence diagram operation lines set correctly after loading.

* prefix of document files changed from kde_libs_htmldir to kde_htmldir to allow documents to be installed where you like

* footnote added when printing

* fixed printing so print multiple pages is now correct

* popup menu coordinates fixes for popup menus and list view

* Diagram made bigger

* drag and drop now correct on large diagram




Version 1.0 (5/09/2001)

* Started maintaining ChangeLog file

* Setup mime type correctly

* Fixed Layout Managers on GUIs

* Added scope to the Concepts on Class/Concept diagrams
	+ Public, - Private, # Protected

* Fixed install so can install in the directory you wish (I hope - Let me know 
if this works)

* Removed hard coding of file location from program

* File Extension ".uml" added if user didn't

* Removed HTML welcome screen due to loading time.

* Changed the icons setup by KDevelop (someone please design better ones)

* Has i18n ready to go, just need translators (any takers?)

* Text Lines e.g. messages, lines of text, etc. are printed transparently.

* Association prop. Dialog now has default OK button instead of Cancel.

* Added options page for UML icons

* Objects set to correct background colour when not using fill colour


